//+------------------------------------------------------------------+
//|                                                TEST EA.mq4       |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern double  lots           = 0.01;
extern int     Stop_Loss      = 1000;
extern int     Take_Profit    = 5000;
extern bool    BUY            = true;
extern bool    SELL           = true;
double         stop,prof,bluearrow,yellowarrow,ticknow;
int            iTrade,cnt;
bool           closebuy,closesell,checkorder;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   checkorder=true;
   closebuy=false;
   closesell=false;
//=====================================================================  
   for(iTrade=0;iTrade<OrdersTotal();iTrade++)
           {
            if (OrderSelect(iTrade,SELECT_BY_POS,MODE_TRADES))
               {
                if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
                  {
                    checkorder=false;
                    closebuy=true;
                  }
                if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
                  {
                    checkorder=false; 
                    closesell=true;
                  }
               }
           }
//======================================================================          
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

   bluearrow    = iCustom(Symbol(), 0, "TargetX",true,false,false,2,8,18,28, 0,1);
   yellowarrow  = iCustom(Symbol(), 0, "TargetX",true,false,false,2,8,18,28, 1,1);

 //+-----------------------------------------------+
 //| Menentukan Open Posisi untuk Buy              |
 //+-----------------------------------------------+   
   if (checkorder)             // Menentukan Open Posisi untuk Buy
       {     
        if (BUY)
          {
            if ( bluearrow > 0 && bluearrow < 99999)
               {
                if (OrderSend(Symbol(), OP_BUY, lots, Ask, 5, 0, 0) > 0)
                   {
                    ticknow=Ask;
                     checkorder=false;
                     closebuy=true;
                     return(0);
                    }
                 }
           }
        
        if (SELL)
             {         
              //  Menentukan Open Posisi untuk Sell 
              if (yellowarrow > 0  && yellowarrow < 99999)
                { 
                 if(OrderSend(Symbol(), OP_SELL, lots, Bid, 5, 0, 0) > 0)
                   {
                    ticknow=Bid;
                    checkorder=false;
                    closesell=true;
                    return(0);
                   }
                }
             }
          
       }
  
          
           
//+-----------------------------------+
//| Menentukan Close Posisiby Signal  |
//+-----------------------------------+
  closing();
//----
   return(0);
  }
//+------------------------------------------------------------------+

void closing()
{ 
  if (closebuy)
  {
   if ((yellowarrow > 0  && yellowarrow < 99999) || (Bid > ticknow+Take_Profit*Point || Bid < ticknow-Stop_Loss*Point))   
      {
        for(iTrade=0;iTrade<OrdersTotal();iTrade++)
           {
            if (OrderSelect(iTrade,SELECT_BY_POS,MODE_TRADES))
              {
               if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
                  {
                   //====================================  Martiangle
                   if(OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet))
                     {
                      closebuy=false;
                      checkorder=true;
                     }
                   } 
              }
           }
      }
   }
  if (closesell)
  {
   if (( bluearrow > 0 && bluearrow < 99999 ) || (Ask < ticknow-Take_Profit*Point || Ask > ticknow+Stop_Loss*Point)) 
      {
       for(iTrade=0;iTrade<OrdersTotal();iTrade++)  
          {
           if (OrderSelect(iTrade,SELECT_BY_POS,MODE_TRADES))
              {
                if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
                  {
                    if(OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet))
                       {
                        closesell=false;
                        checkorder=true;
                       }
                   }
              
              }
          }
      }
   }
}


